c---------------------------- ranlfg.inc -------------------------------
c---+----|----+----|----+----|----+----|----+----|----+----|----+----|--
c
c      parameters for lagged fibonacci generators and common block with
c      generator state
c
c-----------------------------------------------------------------------
c
c      possible (np,nq) values, (np,np-nq) is also valid:
c              (17,5), (250,103), (521,158), (1279,418),
c              (2281,715), (4423,1393), (1279,1063)
c      ref.: Bhanot et al., phys. rev b 33, 7841 (1986);
c            Zierler, inf. control 15, 67 (1961)
c
c      mersenne prime primitive trinomials:
c      (heringa et al. int.j.mod.phys.c 3, 561 (1992))
c
c      (89,38)
c      (127,1), (127,7), (127,15), (127,30), (127,63)
c      (521,32), (521,48), (521,158), (521,168)
c      (607,105), (607,147), (607, 273)
c      (1279,216), (1279,418)
c      (2281,715), (2281,915), (2281,1029)
c      (3217,67), (3217,576)
c      (4423,271), (4423,369), (4423,370), (4423,649), (4424,1393),
c                  (4423,1419), (4423,2098)
c      (9689,84), (9689,471), (9689,1836), (9689,2444), (9689,4187)
c      (19937,881), (19937,7083), (19937,9842)
c      (23209,1530), (23209,6619), (23209,9739)
c      (44497,8575), (44497,21034)
c      (110503,25230), (110503,53719)
c      (132049,7000), (132049,33912), (132049,41469), (132049,52549),
c                     (132049,54454)
c
c      another pair from brent92 who recommends q=0.618p : (258,175) 
c      brent's ranu4 uses (132049,79500)
c
c-----------------------------------------------------------------------
c     parameter (np=250,nq=103)
      integer np,nq
      parameter (np=1279,nq=418)
c     parameter (np=2281,nq=715)
c      parameter (np=274674,nq=67874)
      integer init
      integer last
      double precision x(np) !???  
      save /xrandf/  
      common /xrandf/ x,last,init
c---+----|----+----|----+----|----+----|----+----|----+----|----+----|--
c----------------------------- last line -------------------------------
